function [X,out_cell,out_model]=NMoG_Tucker(Y,par)
time_all=tic;
%% 
out_cell=cell(1,2);%
out_model=cell(1,2);%
%% 
if ndims(Y)>3
    error('only support 2-D and 3-D data')
end
if ~exist('par','var');par=[];end
par_all=subf_par_init(Y,par);%
var_uv=[];
var_rank=[];
var_dim=[];
%% 
for stage=par_all.iter.stage
    time_stage=tic;%
    fprintf('Stage %d running...\n',stage);
    %% 
    [res,var_rank,var_uv,var_mog,var_dim]=subf_var_init(var_uv,var_rank,var_dim,Y,par_all,stage);
    %% 
    for iter=1:par_all.iter.max
        for dim=var_dim.active
            %% 
            [var_uv(dim),var_rank(dim),res]=subf_uv_rank_update(var_uv(dim),var_rank(dim),res,var_mog(dim),var_dim,Y,par_all,stage,iter,dim);
            %% 
            var_mog(dim)=subf_mog_update(var_mog(dim),var_uv(dim),Y,par_all,stage);
        end
        if par_all.others.detail_show;fprintf('\n');end
        %% 
        var_dim=subf_dim_update(var_dim,var_uv,var_rank,Y,par_all,stage,iter);
        %% 
        res=subf_res_update(res,var_dim,var_uv,var_rank,var_mog,Y,par_all,iter,0);
        %% 
        switch stage
            case 1
                stop_flag=all([var_rank(var_dim.active).stable]>=4) && var_dim.cr<par_all.iter.tol(stage) && ...
                    (var_dim.xi0_zero || (var_dim.xi0>=1000 && max(var_dim.cr_X_minus_UVt(var_dim.active))<par_all.iter.tol_X_minus_UVt));
            case 2
                stop_flag=iter>=par_all.rank.sequ_length && var_dim.cr<par_all.iter.tol(stage) && ...
                    (var_dim.xi0_zero || var_dim.xi0>=1000);
        end
        if stop_flag
            break;
        end
    end
    %% 
    res=subf_res_update(res,var_dim,var_uv,var_rank,var_mog,Y,par_all,iter,stage);
    res.time_stage=toc(time_stage);
    out_cell{stage}=struct_show_mth(res,res.show);
    %out_model{stage}.UVt={var_uv.UVt};
    %out_model{stage}.Z_tau={var_mog.Z_tau};
    out_model{stage}.X=var_dim.X;
    out_model{stage}.res=res;
    fprintf('Stage %d done\n',stage);
end
X=var_dim.X;
time_all=toc(time_all);
par_all.loc=[];%
par_all.others.X_ori=[];
out_cell=cat_mth(2,vars_show_mth(2,time_all,par_all),cat_mth(1,out_cell{1},out_cell{2}));
end