%% Description
%Demo for
%Tian-Hui Ma, Zongben Xu, Deyu Meng, 
%Remote sensing image denoising via low-rank tensor approximation and robust noise modeling, 
%Remote Sensing, vol. 12, no. 8, 2020, Article ID 1278, doi:10.3390/rs12081278.
%This work should be used only for nonprofit purposes.
%If you have any comment, suggestion, or question, please contact Tian-Hui Ma at: nkmth0307@126.com.
%% Generate noisy data
clear;clc;close all;pack;
addpath(genpath('tools'));
m=[50 50 50];r=[10 10 10];
X_ori=tmms_mth(randn(r),{randn(m(1),r(1)),randn(m(2),r(2)),randn(m(3),r(3))});
X_ori=X_ori/mean2(abs(X_ori(:)));
Y=X_ori+0.1*randn(size(X_ori));
%% Run code
par=struct;
par.data_type='syn';
%data_type:
% 'syn' for synthetic data
% 'msi' for multispectral image
% 'hsi' for hyperspectral image
% 'real' for real hyperspectral image
%par.X_ori=X_ori;%for evaluation purpose, optional
par.detail_show=0;%show details or not
%Y: in 3-D format with intensity range scaled to [0, 1]
t=tic;
[X,out_cell,out_model]=NMoG_Tucker(Y,par);
t=toc(t);
fprintf('time=%.2e(s),ReErr=%.2e\n',t,QAs_mth(X_ori,Y,'ReErr',3));