function var_dim=subf_dim_update(var_dim,var_uv,var_rank,Y,par_all,stage,iter)
%% 
dim_active=var_dim.active;
X_old=var_dim.X;
cr_X_old=var_dim.cr;
w_basic=var_dim.w_basic;
xi0_inited=var_dim.xi0_inited;
xi0_zero=var_dim.xi0_zero;
xi0=var_dim.xi0;
idx_dim={var_rank.idx};
UVt={var_uv.UVt};
cr_dim={var_uv.cr};
cr_dim_old={var_uv.cr_old};
stage_all=par_all.iter.stage;
data_type=par_all.others.data_type;
dim_num=par_all.dim.num;
unfold=par_all.dim.unfold;
true_idx=par_all.loc.true;
noise_idx=par_all.loc.noise;
par_w=par_all.w;
par_rank=par_all.rank;
par_xi=par_all.xi;
%
if stage==2 && any(strcmp(data_type,{'hsi','real'})) && ismember(1,stage_all) && ismember(3,par_all.w.active)
    dim_active=par_all.w.active;
    UVt{1}=var_dim.UVt_stage1{1};
    UVt{2}=var_dim.UVt_stage1{2};
    idx_dim{1}=var_dim.idx_stage1{1};
    idx_dim{2}=var_dim.idx_stage1{2};
end
%% 
if stage==2 && iter==ceil(par_rank.sequ_length/2)
    dim3_w=zeros(3);
    dim3_idx=zeros(3);
    for dim=dim_active
        [~,dim3_idx(dim,:),dim3_w(dim,:)]=sv_table_mth(UVt{dim});
    end
    dim3_ratio=dim3_w(3,3)/mean2(dim3_w(3,1:2))+dim3_w(3,3)/mean2(dim3_w(1:2,3));
    %
    var_dim.dim3_idx=dim3_idx;
    var_dim.dim3_w=dim3_w;
    var_dim.dim3_ratio=dim3_ratio;
end
%% 
%
w_dim=zeros(1,dim_num);
w_dim(dim_active)=ssubf_w(cell2mat(idx_dim(dim_active)),par_w.eta);
%
X_basic=ssubf_X(Y,w_basic(:,dim_active),UVt(dim_active),true_idx);
idx_basic=zeros(1,dim_num);
for dim=dim_active
    sv=sv_mth(unfold{dim}(X_basic));
    [~,~,~,~,idx_basic(dim)]=ssubf_rank_info(sv,par_rank.idx_type);
end
w_X=zeros(1,dim_num);
w_X(dim_active)=ssubf_w(idx_basic(dim_active),par_w.eta);
%
switch stage
    case 1
        w=w_basic;
    case 2
        switch par_w.type
            case 'basic'
                w=w_basic;
            case 'dim'
                w=w_dim;
            case 'X'
                w=w_X;
        end
end
%%
X=ssubf_X(Y,w(:,dim_active),UVt(dim_active),true_idx);
cr_X=norm(X(:)-X_old(:),'fro')/norm(X_old(:),'fro');
idx_X=zeros(1,dim_num);
cr_X_minus_UVt=zeros(1,dim_num);
for dim=dim_active
    sv=sv_mth(unfold{dim}(X));
    [~,~,~,~,idx_X(dim)]=ssubf_rank_info(sv,par_rank.idx_type);
    cr_X_minus_UVt(dim)=norm(X(:)-UVt{dim}(:),'fro')/norm(X(:),'fro');
end
%% 
if any(noise_idx(:))
    var_N=1/var(Y(noise_idx)-X(noise_idx),1);
else
    var_N=1/var(Y-X,1);
end
var_band=1./var(reshape(Y-X,[],size(Y,3)),1,1)';
%
xi_init=~xi0_inited && ...
    (cr_X<=par_xi.tol_X || any([cr_dim{dim_active}]<=par_xi.tol_dim)) && ...
    (stage==1 || (stage==2 && iter>=ceil(par_rank.sequ_length/2)));
%
xi_update=xi0_inited && (cr_X<=min(par_xi.tol_X,cr_X_old) || any([cr_dim{dim_active}]<=min(par_xi.tol_dim,[cr_dim_old{dim_active}])));
if xi_init;xi0=par_xi.ini(stage);xi0_inited=1;end
if xi_update;xi0=xi0*par_xi.rate(stage);end
%
xi0_zero=xi0_zero || numel(dim_active)<=par_xi.dim_min || (stage==2 && any(strcmp(data_type,{'msi','hsi','real'})));
if xi0_zero;xi0=min(xi0,0);end
xi=xi0*min(max(10,var_N),500)/max(w(:));
%% 
var_dim.idx=idx_X;
var_dim.w_dim=w_dim;
var_dim.w_X=w_X;
var_dim.w=w;
var_dim.X=X;
var_dim.cr=cr_X;
var_dim.cr_X_minus_UVt=cr_X_minus_UVt;
var_dim.xi0_inited=xi0_inited;
var_dim.xi0_zero=xi0_zero;
var_dim.var_N=var_N;
var_dim.var_band=var_band;
var_dim.xi0=xi0;
var_dim.xi=xi;
end