function res=subf_res_update(res,var_dim,var_uv,var_rank,var_mog,Y,par_all,iter,stage_done)
%% 
X=var_dim.X;
dim_active=var_dim.active;
dim_active_ini=par_all.w.active;
dim_num=par_all.dim.num;
par_rank=par_all.rank;
data_type=par_all.others.data_type;
X_ori=par_all.others.X_ori;
detail_show=par_all.others.detail_show;
true_idx=par_all.loc.true;
stage_all=par_all.iter.stage;
if ~stage_done
    %% 
    res.cr_X(iter)=var_dim.cr;
    res.mpsnr_X(iter)=QAs_mth(X_ori,X,'psnr',2,1);
    res.err_X(iter)=QAs_mth(X_ori,X,'reerr',3,1);
    res.mog_num{iter}=[var_mog(dim_active).num];
    res.xi0(iter)=var_dim.xi0;
    res.var_N(iter)=var_dim.var_N;
    res.w{iter}=var_dim.w;
    res.w_dim{iter}=var_dim.w_dim;
    res.w_X{iter}=var_dim.w_X;
    for dim=dim_active
        res.cr_dim{iter,dim}=var_uv(dim).cr;
        res.mpsnr_dim{iter,dim}=QAs_mth(X_ori,var_uv(dim).UVt,'psnr',2,1);
        res.err_dim{iter,dim}=QAs_mth(X_ori,var_uv(dim).UVt,'reerr',3,1);
        res.rank_info{iter,dim}=[par_rank.max(dim),var_rank(dim).curr,var_rank(dim).idx,var_dim.idx(dim)];
        res.rank_thre{iter,dim}=var_rank(dim).thre;
        res.cr_X_minus_UVt{iter,dim}=var_dim.cr_X_minus_UVt(dim);
        res.Y_minus_UVt{iter,dim}=norm(Y(:)-var_uv(dim).UVt(:),'fro');
        res.tau{iter,dim}=var_mog(dim).tau;
    end
    %
    if detail_show
        fprintf('iter=%d,xi0=%.3f,tauN=%.1f\n',iter,var_dim.xi0,var_dim.var_N);
        fprintf([' rank  =[' repmat('%7d|',1,numel(dim_active)-1)  '%7d]\n'],[var_rank(dim_active).curr]);
        fprintf([' idx_d =[' repmat('%7.3f|',1,numel(dim_active)-1)  '%7.3f]\n'],[var_rank(dim_active).idx]);
        fprintf([' idx_X =[' repmat('%7.3f|',1,numel(dim_active)-1)  '%7.3f]\n'],var_dim.idx(dim_active));
        fprintf([' w     =[' repmat('%7.3f|',1,numel(dim_active)-1)  '%7.3f]\n'],var_dim.w(dim_active));
        fprintf([' mpsnr =[' repmat('%7.2f|',1,numel(dim_active)-1)  '%7.2f||%7.2f]\n'],res.mpsnr_dim{iter,dim_active},res.mpsnr_X(iter));
        %fprintf([' err   =[' repmat('%7.2e|',1,numel(dim_active)-1)  '%7.2e||%7.2e]\n'],res.err_dim{iter,dim_active},res.err_X(iter));
        fprintf([' cr_dim=[' repmat('%.1e|',1,numel(dim_active)-1)  '%.1e]\n'],res.cr_X_minus_UVt{iter,dim_active});
        fprintf([' cr    =[' repmat('%.1e|',1,numel(dim_active)-1)  '%.1e||%.1e]\n'],res.cr_dim{iter,dim_active},res.cr_X(iter));
    end
else
    %% 
    res.cr_end=res.cr_X(iter);
    res.rank_end=[var_rank.curr];
    res.mpsnr_end=res.mpsnr_X(iter);
    res.psnr_end=QAs_mth(X_ori,X,'psnr',3,1);
    res.err_end=res.err_X(iter);
    res.mog_num_end=res.mog_num{iter};
    res.stage=stage_done;
    res.iter=iter;
    res.dim3_idx=var_dim.dim3_idx;
    res.dim3_w=var_dim.dim3_w;
    res.dim3_ratio=var_dim.dim3_ratio;
    res.w_basic_ini=var_dim.w_basic_ini;
    res.w_basic=var_dim.w_basic;
    res.w_end=var_dim.w;
    %% 
    UVt_cell={var_uv.UVt};
    if any(strcmp(data_type,{'hsi','real'})) && isequal(stage_all,[1,2]) && stage_done==2 && ismember(3,dim_active_ini)
        UVt_cell{1}=var_dim.UVt_stage1{1};
        UVt_cell{2}=var_dim.UVt_stage1{2};
    end
    UVt_temp=zeros(numel(Y),dim_num);
    for dim=dim_active_ini
        UVt_temp(:,dim)=UVt_cell{dim}(:);
    end
    UVt_temp=UVt_temp(:,dim_active_ini);
    %
    w_curr=repmat(var_dim.w(:,dim_active_ini),size(Y,3)/size(var_dim.w,1),1);
    %
    w_opt_whole=UVt_temp\X_ori(:);
    w_opt_whole=w_opt_whole(:)';
    %
    band_pixel=size(Y,1)*size(Y,2);
    w_opt_band=zeros(size(Y,3),numel(dim_active_ini));
    for i3=1:size(Y,3)
        w_opt_band(i3,:)=UVt_temp(((i3-1)*band_pixel+1):(i3*band_pixel),:)\reshape(X_ori(:,:,i3),[],1);
    end
    X_opt_whole=ssubf_X(Y,w_opt_whole,UVt_cell(dim_active_ini),true_idx);
    X_opt_band=ssubf_X(Y,w_opt_band,UVt_cell(dim_active_ini),true_idx);
    psnr_opt=QAs_mth(X_ori,X_opt_whole,'psnr',3,1);
    [mpsnr_opt_mean,mpsnr_opt]=QAs_mth(X_ori,X_opt_band,'psnr',2,1);
    [~,mpsnr_X]=QAs_mth(X_ori,var_dim.X,'psnr',2,1);
    %
    res.w_opt_whole=w_opt_whole;
    res.w_opt_band=[w_opt_band mpsnr_opt(:) w_curr mpsnr_X(:) mpsnr_opt(:)-mpsnr_X(:) var_dim.var_band(:)];
    if isfield(var_dim,'var_band_stage1')
        res.w_opt_band=[res.w_opt_band var_dim.var_band_stage1(:)];
    end
    res.psnr_opt=psnr_opt;
    res.mpsnr_opt=mpsnr_opt_mean;
    %% 
    res.show=[];%
    res.show.scalar={{'stage','time_stage','iter','cr_end','rank_end','rank_dim','mog_num_end'},...
        {'err_init','err_end','psnr_init','psnr_end','mpsnr_init','mpsnr_end'},...
        {'dim3_idx','dim3_w','dim3_ratio'},...
        {'w_basic_ini','w_basic','w_end','w_opt_whole','psnr_opt','w_opt_band','mpsnr_opt'}};
    res.show.vector={'iter_all','cr_dim','cr_X','mpsnr_dim','mpsnr_X','err_X','rank_iter',...
        'rank_info','rank_thre','xi0','var_N','w_dim','w_X','w','cr_X_minus_UVt','mog_num','tau'};
    res.show.num=iter;
end
end