function [res,var_rank,var_uv,var_mog,var_dim]=subf_var_init(var_uv,var_rank,var_dim,Y,par_all,stage)
%% 
var_uv_stage1=var_uv;
var_rank_stage1=var_rank;
var_dim_stage1=var_dim;
%% 
%
iter_max=par_all.iter.max;
dim_num=par_all.dim.num;
X_ori=par_all.others.X_ori;
%
res=[];
res.cr_X=zeros(iter_max,1);%
res.mpsnr_X=zeros(iter_max,1);%
res.err_X=zeros(iter_max,1);%
res.mog_num=cell(iter_max,1);%
res.xi0=zeros(iter_max,1);%
res.var_N=zeros(iter_max,1);%
res.cr_dim=cell(iter_max,dim_num);%
res.mpsnr_dim=cell(iter_max,dim_num);%
res.err_dim=cell(iter_max,dim_num);%
res.rank_info=cell(iter_max,dim_num);%
res.rank_thre=cell(iter_max,dim_num);%
res.w_basic=cell(iter_max,1);%
res.w_dim=cell(iter_max,1);%
res.w_X=cell(iter_max,1);%
res.w=cell(iter_max,1);%
res.cr_X_minus_UVt=cell(iter_max,dim_num);%
res.Y_minus_UVt=cell(iter_max,dim_num);%
res.tau=cell(iter_max,dim_num);%
res.rank_iter=cell(iter_max,1);%
res.rank_dim=cell(dim_num,1);%
res.mpsnr_init=QAs_mth(X_ori,Y,'psnr',2,1);
res.psnr_init=QAs_mth(X_ori,Y,'psnr',3,1);
res.err_init=QAs_mth(X_ori,Y,'ReErr',3,1);
res.iter_all=(1:iter_max)';
%% 
%
stage_all=par_all.iter.stage;
dim_num=par_all.dim.num;
iter_max=par_all.iter.max;
par_rank=par_all.rank;
dim_active=par_all.w.active;
%
var_rank=struct('curr',0,...%
    'sv_avg',0,...%
    'sv_cumsum',0,...%
    'idx',0,...%
    'thre',0,...%
    'stable',0,...%
    'sequence',[]);%
var_rank=repmat(var_rank,[1,dim_num]);
%
switch stage
    case 1
        rank_init=par_rank.init;
    case 2
        if ismember(1,stage_all)%
            rank_end=[var_rank_stage1.curr];
        else%
            rank_end=par_rank.prior;
        end
        rank_init=max(min(rank_end*2,par_rank.init),par_rank.init2);
        for dim=dim_active
            var_rank(dim).sequence=[round(sequence_mth(rank_init(dim),rank_end(dim),[par_rank.sequ_length,par_rank.sequ_power],'linexp')),...
                rank_end(dim)*ones(1,iter_max-par_rank.sequ_length)];
        end
end
%% 
%
dim_num=par_all.dim.num;
dim_active=par_all.w.active;
par_dim=par_all.dim;
uv_init_stage2=par_all.iter.uv_init_stage2;
detail_show=par_all.others.detail_show;
if stage==1
    Y_ini=Y;
else
    switch uv_init_stage2
        case 'noisy'
            Y_ini=Y;
        case 'random'
            rng(0)
            Y_ini=rand(size(Y));
        case 'stage1'
            Y_ini=var_dim_stage1.X;
            rng(0)
            e_ini=randn(size(Y_ini));
            Y_ini=Y_ini+0.5*e_ini/norm(e_ini(:),'fro')*norm(Y_ini(:),'fro');
        case 'given'
            Y_ini=par_all.iter.Y_ini;
    end
end
%
time_UV_init=tic;
var_uv=repmat(struct(),[1,dim_num]);
for dim=dim_active
    Y_temp=par_dim.unfold{dim}(Y_ini);
    rank_init_temp=rank_init(dim);
    scale=sqrt(mean2(Y_temp.^2));%
    [m,n]=size(Y_temp);
    [U,S,V]=svd_mth(Y_temp);
    S=diag(S(1:rank_init_temp).^0.5);
    U=U(:,1:rank_init_temp)*S;
    V=V(:,1:rank_init_temp)*S;
    U_sigma=scale*repmat(eye(rank_init_temp),[1,1,m]);
    UtU=zeros(rank_init_temp,rank_init_temp,m);
    for i=1:m
        UtU(:,:,i)=U_sigma(:,:,i)+U(i,:)'*U(i,:);
    end
    UtU=reshape(UtU,[],m);
    V_sigma=scale*repmat(eye(rank_init_temp),[1,1,n]);
    VtV=zeros(rank_init_temp,rank_init_temp,n);
    for i=1:n
        VtV(:,:,i)=V_sigma(:,:,i)+V(i,:)'*V(i,:);
    end
    VtV=reshape(VtV,[],n);
    UV_gamma=(1/scale)*ones(rank_init_temp,1);
    UVt=par_dim.fold{dim}(U*V');
    %
    var_uv(dim).U=U;
    var_uv(dim).U_sigma=U_sigma;
    var_uv(dim).UtU=UtU;
    var_uv(dim).V=V;
    var_uv(dim).V_sigma=V_sigma;
    var_uv(dim).VtV=VtV;
    var_uv(dim).UV_gamma=UV_gamma;
    var_uv(dim).UVt=UVt;%
    var_uv(dim).UVt2=[];
    var_uv(dim).cr=0;%
    var_uv(dim).cr_old=0;%
end
time_UV_init=toc(time_UV_init);
if detail_show;fprintf('time_UV_init=%.2e\n',time_UV_init);end
%% 
%
dim_num=par_all.dim.num;
dim_active=par_all.w.active;
mog_num=par_all.mog.num;
noise_idx=par_all.loc.noise;
true_idx=par_all.loc.true;
miss_idx=par_all.loc.miss;
par_model=par_all.model;
%
var_mog=repmat(struct(),[1,dim_num]);
for dim=dim_active
    N=Y-var_uv(dim).UVt;
    Z=zeros(numel(N),mog_num);
    N=N(noise_idx);
    N=N(:)';
    if any(noise_idx)
        Z_temp=l2_clustering_mth(N,mog_num);%
    else
        Z_temp=zeros(0,mog_num);
    end
    a=par_model.a0+1/2*sum(Z_temp,1);%
    b=par_model.b0+1/2*(N.^2)*Z_temp;%
    tau=a./b;
    Z(noise_idx,:)=Z_temp;
    Z_tau=reshape(Z*tau',size(Y));%
    Z_tau(miss_idx)=0;
    if stage==1
        Z_tau(true_idx)=1e2*max(1,max(abs(Y(:))));
    else
        Z_tau(true_idx)=1e10*max(1,max(abs(Y(:))));
    end
    %
    var_mog(dim).Z=Z;
    var_mog(dim).tau=tau;
    var_mog(dim).Pi=[];
    var_mog(dim).num=mog_num;
    var_mog(dim).Z_tau=Z_tau;
end
%% 
%
dim_num=par_all.dim.num;
dim_active=par_all.w.active;
stage_all=par_all.iter.stage;
par_w=par_all.w;
true_idx=par_all.loc.true;
data_type=par_all.others.data_type;
%
var_dim=[];
%
switch stage%
    case 1
        w_basic_ini=zeros(1,dim_num);
        w_basic_ini(dim_active)=1/numel(dim_active);
        w_basic=w_basic_ini;
    case 2
        if ismember(1,stage_all)%
            w_basic_ini=zeros(1,dim_num);
            w_basic_ini(dim_active)=ssubf_w(var_dim_stage1.idx(dim_active),par_w.eta);
        else%
            w_basic_ini=par_w.basic;
        end
        w_basic=w_basic_ini;
        %
        switch data_type
            case 'msi'
                if ismember(1,stage_all) && ismember(3,dim_active)
                    if var_dim_stage1.var_N>100
                        w_basic(3)=min([0.75,w_basic(3)+0.5]);
                    else
                        w_basic(3)=min([0.95,w_basic(3)+0.8]);
                    end
                    w_basic(1:2)=w_basic(1:2)/max(sum(w_basic(1:2)),eps)*(1-w_basic(3));
                end
                w_basic(dim_active)=w_basic(dim_active)/sum(w_basic(dim_active));
                w_basic(setdiff(1:dim_num,dim_active))=0;
            case {'hsi','real'}
                if ismember(1,stage_all) && ismember(3,dim_active)
                    w_basic(:,3)=0.98;
                    w_basic(:,1:2)=w_basic(:,1:2)./repmat(max(sum(w_basic(:,1:2),2),eps),1,2).*repmat(1-w_basic(:,3),1,2);
                end
                w_basic(:,dim_active)=w_basic(:,dim_active)./repmat(sum(w_basic(:,dim_active),2),1,numel(dim_active));
                w_basic(:,setdiff(1:dim_num,dim_active))=0;
                if ismember(1,stage_all) && ismember(3,dim_active)
                    dim_active=3;%
                end                    
        end
end
%
var_dim.var_N=0;
var_dim.var_band=zeros(size(Y,3),1);
var_dim.xi=0;%
var_dim.xi0=0;%
var_dim.xi0_inited=0;%
var_dim.xi0_zero=0;%
%
var_dim.w_basic=w_basic;
var_dim.w_basic_ini=w_basic_ini;
var_dim.w_dim=zeros(1,dim_num);
var_dim.w_X=zeros(1,dim_num);
var_dim.w=zeros(1,dim_num);    
if stage==2 && ismember(1,stage_all)
    var_dim.var_band_stage1=var_dim_stage1.var_band;
    var_dim.UVt_stage1={var_uv_stage1.UVt};
    var_dim.idx_stage1={var_rank_stage1.idx};
end
%
X=ssubf_X(Y,w_basic(:,dim_active),{var_uv(dim_active).UVt},true_idx);
var_dim.X=X;
var_dim.idx=zeros(1,dim_num);%
var_dim.cr=0;%
cr_X_minus_UVt=zeros(1,dim_num);
for dim=dim_active
    cr_X_minus_UVt(dim)=norm(X(:)-var_uv(dim).UVt(:),'fro')/norm(X(:),'fro');
end
var_dim.cr_X_minus_UVt=cr_X_minus_UVt;%
var_dim.active=dim_active;  
%
var_dim.dim3_idx=[];
var_dim.dim3_w=[];
var_dim.dim3_ratio=[];
end