function A=cat_mth(dim,varargin)
var=varargin;
if isnumeric(dim)
    A=cat_data_mth(dim,var);
elseif strcmp(dim,'struct')
    A=cat_struct_mth(dim,var);
else
    error('wrong input: dim')
end
end
function A=cat_data_mth(dim,var)
input_check_mth(dim,'n',1,1,[],1);%
n=numel(var);
s=cell(1,n);
d=zeros(1,n);
class=zeros(1,n);
%
for i=1:n
    if isnumeric(var{i})
        class(i)=1;
    elseif iscell(var{i})
        class(i)=2;
    else
        error('only support numeric and cell data')
    end
    s{i}=size(var{i});
    d(i)=ndims(var{i});
end
if any(class==1) && any(class==2)
    change2cell=1;
else
    change2cell=0;
end
dmax=max(dim,max(d));
%
s1=zeros(n,dmax);
ind=cell(n,dmax);
for i=1:n
    s1(i,:)=[s{i} double(~isempty(var{i}))*ones(1,dmax-d(i))];%
    for j=1:dmax
        ind{i,j}=1:s1(i,j);
    end
end
smax=repmat(max(s1,[],1),n,1);
smax(:,dim)=s1(:,dim);
%
for i=1:n
    if change2cell
        temp=cell(smax(i,:));
        if class(i)==1
            var{i}=num2cell(var{i});
        end
    else
        if class(i)==1
            temp=zeros(smax(i,:));
        else
            temp=cell(smax(i,:));
        end
    end
    temp(ind{i,:})=var{i};
    var{i}=temp;
end
A=cat(dim,var{:});
end
function  A=cat_struct_mth(dim,var)
input_check_mth(dim,'c','struct');
n=numel(var);
A=struct;
for i=1:n
    if ~(isstruct(var{i}) && numel(var{i})==1)
        error('wrong input: struct')
    end
    field_name_temp=fieldnames(var{i});
    field_name_repetitive=intersect(fieldnames(A),field_name_temp);
    if ~isempty(field_name_repetitive)
        for k=1:length(field_name_repetitive)-1
            field_name_repetitive{k}=[field_name_repetitive{k} ', '];
        end
        warning(['find repetitive fields: ' field_name_repetitive{:}])
    end
    for j=1:length(field_name_temp)
        A.(field_name_temp{j})=var{i}.(field_name_temp{j});
    end
end
end