function [S,gini,w]=sv_table_mth(X,method,plot_flag)
input_check_mth(X);
if ~exist('plot_flag','var') || isempty(plot_flag)
    plot_flag=0;
end
n=ndims(X);
sizeX=size(X);
if ~exist('method','var') || isempty(method)
    method='tucker';
end
switch method
    case {'Tucker','tucker'}
        num=n;
        if n==2;num=1;end
        unfold_funchdl=@(X,ind)unfold_mth(X,ind);
    case {'Train','train'}
        num=n-1;
        unfold_funchdl=@(X,ind)reshape(X,prod(sizeX(1:ind)),[]);
    otherwise
        error('Unknown method')
end
sv=cell(1,num);sv_org=sv;sv_inv=sv;sv_cumsum=sv;S={};
gini=zeros(1,num);
fpqmean=@(x,p,q)((mean(x.^p))^(1/p))/((mean(x.^q))^(1/q));
fgini=@(x)2*sum(x(end:-1:1).*(length(x)+0.5-[1:length(x)])/length(x))/sum(x);
q=2;p=1/q;
data=cell(1,num);col=cell(1,num);
for i=1:num
    dim=num2str(i);
    unfold_matrix=unfold_funchdl(X,i);
    sv_org{i}=sv_mth(unfold_matrix);
    sv{i}=sv_org{i}/max(sv_org{i});
    sv_inv{i}=1./sv{i};
    sv_cumsum{i}=cumsum(sv{i})/sum(sv{i});
    sv_avg=mean(sv{i});
    sv_cumsum_avg=sum(1./sv_cumsum{i}-1)/length(sv_cumsum{i});
    lr_idx=1/2*sv_avg+1/2*sv_cumsum_avg;
    pq_mean=fpqmean(sv{i},p,q);
    gini(i)=fgini(sv{i}(:)');
    col{i}={['sv_avg' dim];sv_avg;...
        ['sv_cumsum_avg' dim];sv_cumsum_avg;...
        ['lr_idx' dim];lr_idx;...
        ['pq_mean' dim];pq_mean;...
        ['gini' dim];gini(i);...
        ['weight' dim];0};
    top={['sv' dim] ['sv_inv' dim] ['sv_cumsum' dim]};
    data{i}=[top;num2cell([sv{i} sv_inv{i} sv_cumsum{i}]);top];
end
w=exp(-gini/min(gini));w=w/sum(w);
for i=1:num
    col{i}{end}=w(i);
    S=cat_mth(2,S,col{i},data{i});
end
if plot_flag
    for i=1:num
    par.legend_str{i}=['$\sigma(X_{(' num2str(i) ')})$,Gini=' num2str(gini(i),'%.4f')];
    end
    par.legend_ipt='LaTex';
    par.legend_loc='NorthEast';
    par.tick_y=[0:0.1:1];
    par.point_flag=0;
    par.data_y=sv;
    par.data_y=sv_cumsum;
    plot_mth(par)
end
end

