function [U,S,V,rank_Z,err_eig]=svd_mth(Z,econ)
%% 
if ~ismatrix(Z)
    error('matrices only')
end
if ~exist('econ','var') || isempty(econ)
    econ=0;
end
[m,n]=size(Z);
left=(m<n)&&(nargout==1);%
small_scale=(m*n<1000^2) || (left && m<1000);%
%% 
if small_scale
    if left
        [U,~,~]=svd(Z*Z','econ');
    else
        [U,S,V]=svd(Z,'econ');
        S=diag(S);
    end
    rank_Z=[];
    err_eig=[];
    return;
end
%% 
trans=m>n;%
if trans%
    Z=Z';
    temp=m;m=n;n=temp;
end
%% 
ZZt=Z*Z';
ZZt=ZZt/(trace(ZZt)/m);%
[U,S]=eig(ZZt);
U=U(:,end:-1:1);
S=max(0,diag(real(S)));
S=S(end:-1:1);
rank_Z=sum(S>(m*eps(S(1))));
%% 
VS=Z'*U(:,1:rank_Z);%Z=USV',Z'*U=V*S
S=sqrt(sum(abs(VS).^2,1));S=S(:);
V=VS*diag(1./S);
%% 
err_eig=[norm(V'*V-eye(size(V,2)),'fro') norm(U(:,1:rank_Z)*diag(S)*V'-Z,'fro')];
change2svd=any(err_eig>m^2*max(1e-10,eps(S(1))));
if change2svd
    warning(['eig error||VtV-I||=' num2str(err_eig(1),'%.2e') ',||USVt-Z||=' num2str(err_eig(2),'%.2e') ',change to svd'])
    if left
        [U,~,~]=svd(ZZt,'econ');
    else
        [U,S,V]=svd(Z,'econ');
        S=diag(S);
    end
end
%% 
if ~change2svd
    if econ
        U=U(:,1:rank_Z);
    end
    if ~econ && ~left && rank_Z<m%
        qr_E=eye(n);
        qr_num=m-rank_Z;
        qr_r=0;
        res=[];
        qr_start=0;
        while qr_r<1e-10
            qr_E_temp=qr_E(:,qr_start+1:qr_start+qr_num);
            res=[res qr_E_temp-V*(V'*qr_E_temp)];%
            [V1,R,~]=qr(res,0);%
            qr_r=abs(R(qr_num,qr_num));
            qr_start=min(qr_start+qr_num,n-qr_num);
        end
        V=[V V1(:,1:qr_num)];
        S=[S;zeros(qr_num,1)];%
    end
end
%% 
if trans
    temp=U;U=V;V=temp;
end
end